var filter = "off";
var filterOrg = "";
var snapper = "";

//var campusID = "672017c9-bb1d-4387-9faa-1960d3f45fa6";
var campusID = "bb726c61-528d-43a4-8268-eb145741bd73";

$(document).ready( function() {
    $("#campus a:first-child").click( function(){
        if( snapper.state().state=="left" ){
            snapper.close();
        } else {
            snapper.open('left');
        }
    });

    snapper = new Snap({
      element: document.getElementById('content'),
      disable: 'right'
    });
});

$(document).on('pagebeforeshow', '#events', function TheEventList(){

	var Jcampus = $.getJSON( "https://admin.checkimhere.com/201204/json/a9677/list/events/" + campusID, function(campus) {
                            console.log( "events json success" );
            
            // EMPTY VARIABLES
            $('#campus h1').empty();
            $('#list').empty();
            $('#orgList').empty();
            $('#tagList').empty();
            
            // ADD CAMPUS NAME
            $("#campus h1").append(campus.orgName);
            $("#campus h1").attr("aria-label", campus.orgName);
            
            // CREATE VARIABLES
            var appendEvents = "";
            var buildOrgs = "";
            var orgArray = [];
            var buildTags = "";
            var tagArray = [];

            eventsEmpty = campus.events;

            if (! eventsEmpty){
                appendEvents = "<p class=\"empty\" aria-label=\"There are currently no events in the next 30 days.\">There are currently no events in the next 30 days.</p>"
            } else {

            // LOOP EVENTS
            $.each(campus.events, function(i, item) {

                // CHECK IF PUBLIC
                if (item.isPrivateToSubOrg == false && item.eventStatus == 'Published'){
                    //SIMPLIFY DATES AND TITLES
                    var date = item.startLocal.slice( 0, 10 );
                    var time = item.startLocal.slice( 11, 19 );
//                    var title = item.eventTitle.toLowerCase();
                    var title = item.eventTitle;
                    if (item.attendanceActual > 0) {
                        if (item.attendanceActual > 50) {
                            var popular = " high";
                        } else {
                            var popular = "";
                        }
                    } else {
                        var popular = " hide";
                    }

                    //CHECK IF ORG FILTER EXISTS AND ADD LINK TO FILTER IF NOT
                    if (jQuery.inArray(item.subName, orgArray) == -1) {
                        orgArray.push( item.subName );
                    }

                    eventTags = [];

                    $.each(item.eventElements, function(i, item) {
                        if ($.inArray(item.eleDescr, tagArray) == -1){
                          tagArray.push( item.eleDescr );
                        }
                        eventTags.push(item.eleDescr);
                    });

                    //console.log(tagArray);

                    if (filter == "off") {
                        //ADD EVENT TO LIST
                   appendEvents += "<li><a data-transition=\"slide\" title=\"" + item.eventId + "\" href=\"#single-event\"><p class=\"date-time longDateFormat\" aria-label=\"" + date + " " + time + "\">" + date + " " + time + "</p><h2 aria-label=\"" + title + "\">" + title + "</h2><p class=\"club-name\" aria-label=\"" + item.subName + "\">" + item.subName + "</p></a></li>";
                    } else if (filterTo == item.subName) {
                        appendEvents += "<li><a data-transition=\"slide\" title=\"" + item.eventId + "\" href=\"#single-event\"><p class=\"date-time longDateFormat\" aria-label=\"" + date + " " + time + "\">" + date + " " + time + "</p><h2 aria-label=\"" + title + "\">" + title + "</h2><p class=\"club-name\" aria-label=\"" + item.subName + "\">" + item.subName + "</p></a></li>";
                    } else if ( $.inArray(filterTo, eventTags) >= 0 ) {
                        console.log("is " + filterTo + " in " + tagArray + "? Then event: " + title);
                        appendEvents += "<li><a data-transition=\"slide\" title=\"" + item.eventId + "\" href=\"#single-event\"><p class=\"date-time longDateFormat\" aria-label=\"" + date + " " + time + "\">" + date + " " + time + "</p><h2 aria-label=\"" + title + "\">" + title + "</h2><p class=\"club-name\" aria-label=\"" + item.subName + "\">" + item.subName + "</p></a></li>";
                    }
                }
            });

        }

            //CREATE EVENT LIST
            $("#list").append(appendEvents);
                            
            // CREATE ORG FILTER LIST
            orgArray.sort();
            $.each(orgArray, function(i, item) {
                buildOrgs += "<li id=\"" + item + "\" class=\"ui-li-static ui-body-inherit\">" + item + "</li>";
            });
            $("#orgList").append(buildOrgs);
            
            if ( tagArray.length > 0 ) {
                tagArray.sort();
                $.each(tagArray, function(i, item) {
                    buildTags += "<li id=\"" + item + "\" class=\"ui-li-static ui-body-inherit\">" + item + "</li>";
                });
                $("#tagList").append(buildTags);
            } else {
                $(".tag-filters").css("display", "none");
            }
                            
            // UPDATE JSON AND LOAD SINGLE EVENT PAGE ON CLICK
            $("a").click( campus.events, function(i, item) {
               var eventId = $(this).attr('title');
               var singleEventId = eventId;
               
               $("#event-id").html(eventId);
            });

            // FILTER EVENTS WHEN ORG CLICKED
            $("#orgList li, #tagList li, .reset-filter").click( function(){

                if ( $(this).attr('filter') == "off" ) {

                    snapper.close();

                    filter = "off";

                    TheEventList();

                    $(".reset-filter").remove();

                } else {

                    snapper.close();

                    filter = "on";

                    filterTo = $(this).attr('id');

                    TheEventList();

                    // $(this).addClass

                    $(".reset-filter").remove();
                    $(".ui-collapsible-set").append("<span filter=\"off\" class=\"ui-li-static ui-body-inherit reset-filter\">Reset Filter</span>");
                }
            });
            
            // REFRESH EVENT LIST
            $("#list").listview("refresh");
            
            dtformat();
            
            $('.refresh').click( function(){
              TheEventList();
            });
            
            })
.done(function() {})
.fail(function() {})
.always(function() {});
// Set another completion function for the request above
Jcampus.complete(function() {});

});


$(document).on('pagebeforeshow', '#single-event', function TheSingleEvent(){

	var theEventId = $("#event-id").html();

	var Jevent = $.getJSON( "https://admin.checkimhere.com/201204/json/a9677/event/" + theEventId, function(theEvent) {
	  console.log( "event json success" );

    // Clear Past Event Details
	 	$('#event-title h1').empty();
	 	$('#event-list').empty();

	 	var eventtitle = theEvent.eventTitle;
        var date = theEvent.startLocal.slice( 0, 10 );
        var time = theEvent.startLocal.slice( 11, 19 );
        var eventlocation = theEvent.eventLocation;
        var eventDes = theEvent.eventDescr;
        var icalstart = theEvent.startLocal.replace(/T/g, ' ');
        var icalend = theEvent.endLocal.replace(/T/g, ' ');
       
	    // Populate the Page
		$("#event-title h1").append(theEvent.orgName);
        if (theEvent.hasImage == true){
        $("#event-list").append("<div class=\"the-event\"><h4 class=\"date-time longDateFormat\">" + date + " " + time + "</h4><img class=\"event-photo\" src=\"http://admin.checkimhere.com/image/get/webfile/" + theEventId + "\"aria-hidden=\"true\"/><div class=\"event-content\"><h2>" + eventtitle + "</h2><h3> Hosted by " + theEvent.subName + "</h3><p class=\"desc\">" + eventDes + "</p><strong> Location: " + eventlocation + "</strong><a class=\"ical ui-btn ui-shadow ui-btn-corner-all ui-btn-up-c ui-btn-up-undefined\" data-role=\"button\" data-icon=\"plus\" data-iconpos=\"left\"><span class=\"ui-btn-inner ui-btn-corner-all\"><span class=\"ui-btn-text\">Add To Calendar</span></span></a></div></div>");
        } else {
        $("#event-list").append("<div class=\"the-event\"><h4 class=\"date-time longDateFormat\">" + date + " " + time + "</h4><div class=\"event-content\"><h2>" + eventtitle + "</h2><h3> Hosted by " + theEvent.subName + "</h3><p class=\"desc\">" + eventDes + "</p><strong> Location: " + eventlocation + "</strong><a class=\"ical ui-btn ui-shadow ui-btn-corner-all ui-btn-up-c ui-btn-up-undefined\" data-role=\"button\" data-icon=\"plus\" data-iconpos=\"left\"><span class=\"ui-btn-inner ui-btn-corner-all\"><span class=\"ui-btn-text\">Add To Calendar</span></span></a></div></div>");
        }
             
       // Add Event To Calendar, Hurray!
       try {
       //var cal = new calendarPlugin();
       
       console.log("creating event");
       var title= eventtitle;
       var location = eventlocation;
       var notes = eventDes;
                           
        // Format for JS date requirements:
        var startArr = datePartsForCalendar(icalstart);
        var endArr = datePartsForCalendar(icalend);
        var startDate = new Date(startArr[0], startArr[1], startArr[2], startArr[3], startArr[4],0,0,0); // beware: month 0 = january, 11 = december
        var endDate = new Date(endArr[0], endArr[1], endArr[2], endArr[3], endArr[4],0,0,0);
                           
       // 2014-07-30 17:00:00
       // 2014,2,15,18,30,0,0,0 // beware: month 0 = january, 11 = december
                           
       var errCall = function(theerror) {
           alert("Error occurred - " + theerror);
       }
                           
       function alertDismissed() {
       // do something
       }
       
                           var succCall = function(themessage) {
                           alert("Success! You added " + eventtitle + " to your calendar.");
       }
       
       }
       catch(e) {
       alert(e.text + ' - ' + e.message);
       }
       
       // Save Event to Calendar on Click
       $('.ical').click(function(){
                        console.log("buttonClick");
           window.plugins.calendar.createEvent(title,location,notes,startDate,endDate, succCall, errCall);
       });
                           
        // Format Dates
		dtformat();

	})
	.done(function() {})
	.fail(function() {})
	.always(function() {});
	// Set another completion function for the request above
	Jevent.complete(function() {});

  $('.refresh').click( function(){
      TheSingleEvent();
  });

});

function datePartsForCalendar(aDate) {
    var dateStr = $.format.date(aDate, "yyyy MM dd HH mm");
    var arr = dateStr.split(' ');
    arr[1] = arr[1]-1;
    //console.log("formatted date = " + dateStr + " parts " + arr);
    return arr;
}

// Format Dates
function dtformat(){
    jQuery.format.date.defaultShortDateFormat = "MMM d";
    jQuery.format.date.defaultLongDateFormat = "ddd, MMM d, h:mm p";

    jQuery(document).ready(function () {
        jQuery(".shortDateFormat").each(function (idx, elem) {
            if (jQuery(elem).is(":input")) {
                jQuery(elem).val(jQuery.format.date(jQuery(elem).val(), jQuery.format.date.defaultShortDateFormat));
            } else {
                jQuery(elem).text(jQuery.format.date(jQuery(elem).text(), jQuery.format.date.defaultShortDateFormat));
            }
        });
        jQuery(".longDateFormat").each(function (idx, elem) {
            if (jQuery(elem).is(":input")) {
                jQuery(elem).val(jQuery.format.date(jQuery(elem).val(), jQuery.format.date.defaultLongDateFormat));
            } else {
                jQuery(elem).text(jQuery.format.date(jQuery(elem).text(), jQuery.format.date.defaultLongDateFormat));
            }
        });
    });
}









